#
#   Albow - Table View
#

from palette_view import PaletteView

class TableView(Column):

	column_margin = 2
	header_data = []
	column_alignments = []

	def __init__(self, column_widths, row_height, nrows, header_height = None,
			scrolling = True, **kwds):
		self.column_widths = column_widths
		if header_height is None:
			header_height = row_height
		row_width = 0
		for w in column_widths:
			row_width += w
		contents = []
		if header_height:
			header = TableHeaderView(row_width, header_height)
			contents.append(header)
		rows = TableRowView((row_width, row_height), nrows, scrolling = scrolling)
		contents.append(rows)
		Column.__init__(self, contents, align = 'l', **kwds)

class TableHeaderView(Widget):

	def __init__(self, width, height):
		Widget.__init__(self, (0, 0, width, height))

	def draw(self, surf):
		table = self.parent
		header_data = table.header_data
		n = len(header_data)
		h = self.height
		m = table.column_margin
		for i, (x, w, a) in enumerate(table.column_info()):
			if i < n:
				data = header_data[i]
			else:
				data = None
			r = Rect(x, 0, w, h)
			self.draw_cell(surf, i, data, a, m, r)
	
	def draw_cell(self, surf, col, data, align, margin, rect):
		if data:
			buf = self.font.render(data, True, self.fg_color)
			blit_in_rect(surf, buf, rect, align, margin)

class TableRowView(PaletteView):

	def __init__(self, cell_size, nrows, scrolling):
		PaletteView.__init__(self, cell_size, nrows, 1, scrolling = scrolling)
	
	def draw_cell(self, surf, row, rect):
		table = self.parent
		?