################################################################
#
#   Assembly Line - Menu Screen
#
################################################################

from albow.resource import get_font
from albow.controls import Button, Column
from screen import ALScreen

menu_font = get_font(24, "VeraBd.ttf")

def always_enabled():
	return True

def no_action():
	return

class MenuScreen(ALScreen):

	bg_color = (0, 0, 0)

	def __init__(self, shell):
		ALScreen.__init__(self, shell)
		mb = self.menu_button
		buttons = [
			mb("New Game", 'new_game'),
			mb("Load Game", 'load_game'),
			mb("Save Game", 'save_game'),
			mb("Resume Game", 'resume_game'),
			mb("Quit", 'quit'),
		]
		menu = Column(buttons, align = 'l')
		c = self.center
		menu.center = self.center
		self.add(menu)

	def menu_button(self, title, action_name):
		enable = getattr(self.game, action_name + '_enabled', always_enabled)
		action = getattr(self.shell, action_name, no_action)
		return Button(title, action = action, enable = enable, font = menu_font)
